$ErrorActionPreference = "Stop" # stop when an error is encountered
#declare variables
$server = "YOURSERVER\\YOURINSTANCE" #slash must be escaped
$connectionString = "Driver={SQL Server Native Client 11.0};Server=$server;Trusted_Connection=yes;" #must be single line
$query = @"
SELECT DATEDIFF(DD, DATEADD(DD, -45, GETDATE()), [bs].[backup_start_date]) [Date], SUM([bs].[backup_size])/1024/1024/1024 [Size] FROM [msdb].[dbo].[backupmediafamily] [bmf] INNER JOIN [msdb].[dbo].[backupset] [bs] ON [bmf].[media_set_id] = [bs].[media_set_id] WHERE [bs].[backup_start_date] >= DATEADD(DD, -45, GETDATE()) AND [bmf].[physical_device_name] LIKE 'D:\\BACKUP\\%' AND [bs].[type] = 'D' GROUP BY DATEDIFF(DD, DATEADD(DD, -45, GETDATE()), [bs].[backup_start_date]) ORDER BY 1
"@ #must be single line
$graphicPath = "D:\\" #slash must be escaped
$graphicName = "image.jpg"
$pathRScript = "C:\Program Files\R\R-3.4.2\bin\x64\" #slash must NOT be escaped
$mailServer = "YOURSMTPSERVER"
$mailFrom = "from@domain.com"
$mailTo = "to@domain.com"
$mailSubject = $server.Replace('\\', '\')+" Size estimate report" #because slash was escaped, here we correct it for the report subject
$RScript = @"
library(RODBC); sqlcnn <- odbcDriverConnect(\"$connectionString\"); data <- sqlQuery(sqlcnn, \"$query\"); close(sqlcnn); x <- data[,2]; qnt <- quantile(x, probs=c(.25, .75), na.rm = T); caps <- quantile(x, probs=c(.05, .95), na.rm = T); H <- 1.5 * IQR(x, na.rm = T); x[x < (qnt[1] - H)] <- caps[1]; x[x > (qnt[2] + H)] <- caps[2]; data[,2] <- x; jpeg(filename=\"$graphicPath$graphicName\"); plot(data, type=\"l\", las=1, col=\"green\", xlim=c(0, 90), ylim=c(650, 750)); model <- lm(Size ~ Date, data); abline(model, col=\"blue\"); x <- 90; y <- round(predict(model, data.frame(Date=c(x)))); points(x, y); text(x, y, y, pos=3); dev.off();
"@ #R code, modify as needed, must be single line
try {
	#generate graphic
	& $pathRScript"RScript.exe" -e "$RScript"
	# Send email
	$image = New-Object System.Net.Mail.LinkedResource("$graphicPath$graphicName", "image/jpg")
	$image.ContentId = $graphicName;
	$alternateView = [Net.Mail.AlternateView]::CreateAlternateViewFromString("<html><body>Data and estimated size<br/><br/><img src='cid:$graphicName'></body></html>", $null, "text/html")
	$alternateView.LinkedResources.Add($image)
	$message = New-Object System.Net.Mail.MailMessage $mailFrom, $mailTo
	$message.Subject = $mailSubject
	$message.IsBodyHTML = $true
	$message.AlternateViews.Add($alternateView)
	$smtp = New-Object Net.Mail.SmtpClient($mailServer)
	$smtp.Send($message)
	$image.Dispose()
	$message.Dispose()
	#delete image
	Remove-Item "$graphicPath$graphicName"
}
catch {
	echo $LastExitCode ($_ | foreach { $_.ToString() } | Out-String)
}